#include "tonecfg.h"

#include "dsk5510.h"
#include "dsk5510_aic23.h"

/* Codec configuration settings */
DSK5510_AIC23_Config config = {
    0x0017, // 0 DSK5510_AIC23_LEFTINVOL  Left line input channel volume
    0x0017, // 1 DSK5510_AIC23_RIGHTINVOL Right line input channel volume
    0x00d8, // 2 DSK5510_AIC23_LEFTHPVOL  Left channel headphone volume
    0x00d8, // 3 DSK5510_AIC23_RIGHTHPVOL Right channel headphone volume
    0x0011, // 4 DSK5510_AIC23_ANAPATH    Analog audio path control
    0x0000, // 5 DSK5510_AIC23_DIGPATH    Digital audio path control
    0x0000, // 6 DSK5510_AIC23_POWERDOWN  Power down control
    0x0043, // 7 DSK5510_AIC23_DIGIF      Digital audio interface format
    0x0081, // 8 DSK5510_AIC23_SAMPLERATE Sample rate control
    0x0001  // 9 DSK5510_AIC23_DIGACT     Digital interface activation
};

extern void filter();      // defined in asmfunctions.asm

Int16 *inPtr;
Int16 *outPtr;
Int16 input[2];
Int16 output[2];

void main()
{
    DSK5510_AIC23_CodecHandle hCodec;

    /* Initialize the board support library, must be called first */
    DSK5510_init();

    /* Start the codec */
    hCodec = DSK5510_AIC23_openCodec(0, &config);

   inPtr = &input[0];
   outPtr = &output[0];

   while(1) {

      while(!DSK5510_AIC23_read16(hCodec, &input[0]));    // read in sample from left channel 
      while(!DSK5510_AIC23_read16(hCodec, &input[1]));    // read in sample from right channel
      filter();

       /* Send a sample to the left channel */
       while (!DSK5510_AIC23_write16(hCodec, output[0]));

       /* Send a sample to the right channel */
       while (!DSK5510_AIC23_write16(hCodec, output[1]));
   }

    /* Close the codec */
    DSK5510_AIC23_closeCodec(hCodec);
}

